> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.0x.org/llms.txt.
> For full documentation content, see https://docs.0x.org/llms-full.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.0x.org/_mcp/server.

# getTxHistory

GET https://api.0x.org/cross-chain/tx-history-beta

Get cross-chain transaction history for a user wallet address. Note: this endpoint is in beta and still a work in progress — please reach out to the 0x team if you or your users run into any issues.

Reference: https://docs.0x.org/api-reference/cross-chain-ap-is/cross-chain/cross-chain-get-tx-history

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: cross-chain
  version: 1.0.0
paths:
  /cross-chain/tx-history-beta:
    get:
      operationId: cross-chain-get-tx-history
      summary: getTxHistory
      description: >-
        Get cross-chain transaction history for a user wallet address. Note:
        this endpoint is in beta and still a work in progress — please reach out
        to the 0x team if you or your users run into any issues.
      tags:
        - subpackage_crossChain
      parameters:
        - name: user
          in: query
          description: >-
            The wallet address of the user to get transaction history for.
            Accepts EVM (0x...), Solana, and Tron addresses
          required: true
          schema:
            $ref: '#/components/schemas/CrossChainTxHistoryBetaGetParametersUser'
        - name: limit
          in: query
          description: Maximum number of transactions to return
          required: false
          schema:
            type: integer
            default: 20
        - name: cursor
          in: query
          required: false
          schema:
            type: string
        - name: 0x-api-key
          in: header
          description: Visit dashboard.0x.org to get your API Key
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Cross-Chain_crossChain::getTxHistory_Response_200
        '400':
          description: 400 error response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/CrossChain::getTxHistoryRequestBadRequestError
        '404':
          description: 404 error response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/CrossChain::getTxHistoryRequestNotFoundError
        '500':
          description: 500 error response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/CrossChain::getTxHistoryRequestInternalServerError
servers:
  - url: https://api.0x.org
components:
  schemas:
    CrossChainTxHistoryBetaGetParametersUser:
      oneOf:
        - type: string
        - type: string
        - type: string
      title: CrossChainTxHistoryBetaGetParametersUser
    CrossChainTxHistoryBetaGetResponsesContentApplicationJsonSchemaTransactionsItems:
      type: object
      properties:
        originChain:
          type: number
          format: double
          description: The origin chain ID
        originTx:
          type: string
          description: The transaction hash on the origin chain
        destinationChain:
          type:
            - number
            - 'null'
          format: double
          description: The destination chain ID
        destinationTx:
          type:
            - string
            - 'null'
          description: The transaction hash on the destination chain
        status:
          type: string
          description: The current status of the transaction
        bridge:
          type:
            - string
            - 'null'
          description: The bridge provider used
      required:
        - originChain
        - originTx
        - destinationChain
        - destinationTx
        - status
        - bridge
      title: >-
        CrossChainTxHistoryBetaGetResponsesContentApplicationJsonSchemaTransactionsItems
    CrossChainTxHistoryBetaGetResponsesContentApplicationJsonSchemaPagination:
      type: object
      properties:
        limit:
          type: number
          format: double
          description: The limit used for this query
        nextCursor:
          type:
            - string
            - 'null'
          description: Cursor for next page. Null if no more results
        hasMore:
          type: boolean
          description: Whether there are more transactions available
      required:
        - limit
        - nextCursor
        - hasMore
      description: Pagination information
      title: >-
        CrossChainTxHistoryBetaGetResponsesContentApplicationJsonSchemaPagination
    Cross-Chain_crossChain::getTxHistory_Response_200:
      type: object
      properties:
        transactions:
          type: array
          items:
            $ref: >-
              #/components/schemas/CrossChainTxHistoryBetaGetResponsesContentApplicationJsonSchemaTransactionsItems
          description: List of transaction history records
        pagination:
          $ref: >-
            #/components/schemas/CrossChainTxHistoryBetaGetResponsesContentApplicationJsonSchemaPagination
          description: Pagination information
        zid:
          type: string
          description: The unique ZeroEx identifier of the request
      required:
        - transactions
        - pagination
        - zid
      title: Cross-Chain_crossChain::getTxHistory_Response_200
    InputInvalidName:
      type: string
      enum:
        - INPUT_INVALID
      title: InputInvalidName
    InputInvalidDataDetailsItems:
      type: object
      properties:
        field:
          type: string
          description: The input field name
        reason:
          type: string
          description: The validation failure reason
      required:
        - field
        - reason
      title: InputInvalidDataDetailsItems
    InputInvalidData:
      type: object
      properties:
        zid:
          type: string
          description: The unique ZeroEx identifier of the request
        details:
          type: array
          items:
            $ref: '#/components/schemas/InputInvalidDataDetailsItems'
          description: The list of invalid inputs
      required:
        - zid
        - details
      title: InputInvalidData
    INPUT_INVALID:
      type: object
      properties:
        name:
          $ref: '#/components/schemas/InputInvalidName'
        message:
          type: string
        data:
          $ref: '#/components/schemas/InputInvalidData'
      required:
        - name
        - message
        - data
      title: INPUT_INVALID
    CrossChain::getTxHistoryRequestBadRequestError:
      oneOf:
        - $ref: '#/components/schemas/INPUT_INVALID'
      title: CrossChain::getTxHistoryRequestBadRequestError
    TransactionNotFoundName:
      type: string
      enum:
        - TRANSACTION_NOT_FOUND
      title: TransactionNotFoundName
    TransactionNotFoundData:
      type: object
      properties:
        zid:
          type: string
          description: The unique ZeroEx identifier of the request
        originChain:
          type: string
        originTxHash:
          type: string
          description: The hash of the transaction on the origin chain
      required:
        - zid
        - originChain
        - originTxHash
      title: TransactionNotFoundData
    TRANSACTION_NOT_FOUND:
      type: object
      properties:
        name:
          $ref: '#/components/schemas/TransactionNotFoundName'
        message:
          type: string
        data:
          $ref: '#/components/schemas/TransactionNotFoundData'
      required:
        - name
        - message
        - data
      title: TRANSACTION_NOT_FOUND
    CrossChain::getTxHistoryRequestNotFoundError:
      oneOf:
        - $ref: '#/components/schemas/TRANSACTION_NOT_FOUND'
      title: CrossChain::getTxHistoryRequestNotFoundError
    InternalServerErrorName:
      type: string
      enum:
        - INTERNAL_SERVER_ERROR
      title: InternalServerErrorName
    InternalServerErrorData:
      type: object
      properties:
        zid:
          type: string
          description: The unique ZeroEx identifier of the request
      required:
        - zid
      title: InternalServerErrorData
    INTERNAL_SERVER_ERROR:
      type: object
      properties:
        name:
          $ref: '#/components/schemas/InternalServerErrorName'
        message:
          type: string
        data:
          $ref: '#/components/schemas/InternalServerErrorData'
      required:
        - name
        - message
        - data
      title: INTERNAL_SERVER_ERROR
    UncategorizedName:
      type: string
      enum:
        - UNCATEGORIZED
      title: UncategorizedName
    UncategorizedData:
      type: object
      properties:
        zid:
          type: string
          description: The unique ZeroEx identifier of the request
      required:
        - zid
      title: UncategorizedData
    UNCATEGORIZED:
      type: object
      properties:
        name:
          $ref: '#/components/schemas/UncategorizedName'
        message:
          type: string
        data:
          $ref: '#/components/schemas/UncategorizedData'
      required:
        - name
        - message
        - data
      title: UNCATEGORIZED
    CrossChain::getTxHistoryRequestInternalServerError:
      oneOf:
        - $ref: '#/components/schemas/INTERNAL_SERVER_ERROR'
        - $ref: '#/components/schemas/UNCATEGORIZED'
      title: CrossChain::getTxHistoryRequestInternalServerError

```

## SDK Code Examples

```python
import requests

url = "https://api.0x.org/cross-chain/tx-history-beta"

querystring = {"user":"0xAb5801a7D398351b8bE11C439e05C5B3259aec9","limit":"20","cursor":"eyJwYWdlIjoxfQ=="}

payload = {}
headers = {
    "0x-api-key": "a1b2c3d4e5f67890123456789abcdef0",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.0x.org/cross-chain/tx-history-beta?user=0xAb5801a7D398351b8bE11C439e05C5B3259aec9&limit=20&cursor=eyJwYWdlIjoxfQ%3D%3D';
const options = {
  method: 'GET',
  headers: {
    '0x-api-key': 'a1b2c3d4e5f67890123456789abcdef0',
    'Content-Type': 'application/json'
  },
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.0x.org/cross-chain/tx-history-beta?user=0xAb5801a7D398351b8bE11C439e05C5B3259aec9&limit=20&cursor=eyJwYWdlIjoxfQ%3D%3D"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("0x-api-key", "a1b2c3d4e5f67890123456789abcdef0")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.0x.org/cross-chain/tx-history-beta?user=0xAb5801a7D398351b8bE11C439e05C5B3259aec9&limit=20&cursor=eyJwYWdlIjoxfQ%3D%3D")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["0x-api-key"] = 'a1b2c3d4e5f67890123456789abcdef0'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.0x.org/cross-chain/tx-history-beta?user=0xAb5801a7D398351b8bE11C439e05C5B3259aec9&limit=20&cursor=eyJwYWdlIjoxfQ%3D%3D")
  .header("0x-api-key", "a1b2c3d4e5f67890123456789abcdef0")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.0x.org/cross-chain/tx-history-beta?user=0xAb5801a7D398351b8bE11C439e05C5B3259aec9&limit=20&cursor=eyJwYWdlIjoxfQ%3D%3D', [
  'body' => '{}',
  'headers' => [
    '0x-api-key' => 'a1b2c3d4e5f67890123456789abcdef0',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.0x.org/cross-chain/tx-history-beta?user=0xAb5801a7D398351b8bE11C439e05C5B3259aec9&limit=20&cursor=eyJwYWdlIjoxfQ%3D%3D");
var request = new RestRequest(Method.GET);
request.AddHeader("0x-api-key", "a1b2c3d4e5f67890123456789abcdef0");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "0x-api-key": "a1b2c3d4e5f67890123456789abcdef0",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.0x.org/cross-chain/tx-history-beta?user=0xAb5801a7D398351b8bE11C439e05C5B3259aec9&limit=20&cursor=eyJwYWdlIjoxfQ%3D%3D")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```